%{
#include <stdio.h>
#include "iscm0.h"
%}
%union {
  void *p;
}
%token <p> ID NUM STR
%token LPAR RPAR
%type <p> exp ls_terms term
%%
ls_exps:	  exp			{ append_exp($1); }
		| ls_exps exp		{ append_exp($2); }
		;
exp:		  LPAR ls_terms RPAR	{ $$ = $2; }
		| LPAR RPAR		{ $$ = nil(); }
		;
ls_terms:	  term			{ $$ = create_pair($1); }
		| ls_terms term		{ $$ = append_to_list($1, $2); }
		;
term:		  ID		{ $$ = $1; }
		| NUM		{ $$ = $1; }
		| STR		{ $$ = $1; }
		| exp		{ $$ = $1; }
		;
%%
int yywrap(){ return 0; }
int yyerror(char *s){ fprintf(stderr, "%s\n", s); }
